import { mochaRun } from '../../../util/helpers.js';
import { ForumTest } from '../forum.test-util.js';

describe('Forum', function tests() {
  this.timeout(0);

  const forumTest = new ForumTest();

  before(async () => {
    await forumTest.setup();
  });

  context('Destroy a post after it has received positive citations', async () => {
    let forum;
    let experts;
    let posts;

    before(() => {
      forum = forumTest.forum;
      experts = forumTest.experts;
      posts = forumTest.posts;
    });

    it('Post1', async () => {
      await forumTest.addPost(experts[0], 100);
      forum.getPost(posts[0]).value.should.equal(100);
    });

    it('Post2 negatively cites Post1', async () => {
      await forumTest.addPost(experts[0], 10, [
        { postId: posts[0], weight: -0.5 },
      ]);
      forum.getPost(posts[0]).value.should.equal(95);
      forum.getPost(posts[1]).value.should.equal(15);
    });

    it('Post3 positively cites Post2', async () => {
      await forumTest.addPost(experts[0], 50, [
        { postId: posts[1], weight: 0.5 },
      ]);
      forum.getPost(posts[0]).value.should.equal(95 - 12.5);
      forum.getPost(posts[1]).value.should.equal(15 + 25 + 12.5);
      forum.getPost(posts[2]).value.should.equal(25);
    });

    it('Post4 negatively cites Post2', async () => {
      await forumTest.addPost(experts[0], 100, [
        { postId: posts[1], weight: -1 },
      ]);
      // forum.getPost(posts[0]).value.should.equal(95 - 12.5);
      // forum.getPost(posts[1]).value.should.equal(15 + 25 + 12.5);
      // forum.getPost(posts[2]).value.should.equal(25);
    });
  });
});

// await addPost(experts[0], 10);
// await addPost(experts[0], 10, [{ postId: posts[3], weight: -1 }]);
// await addPost(experts[0], 10, [{ postId: posts[4], weight: -1 }]);

// await addPost(expert3, 'Post 4', 100, [{ postId: postId2, weight: -1 }]);
// await addPost(expert1, 'Post 5', 100, [{ postId: postId3, weight: -1 }]);

mochaRun();
